/**
 * JOnAS: Java(TM) Open Application Server
 * Copyright (C) 2009 Bull S.A.S.
 * Contact: jonas-team@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id: ConfigurationModel.as 19384 2010-03-08 18:41:14Z mancelin $
 * --------------------------------------------------------------------------
 */

package org.ow2.jonas.admin.auditconsole.model {

/**
 * Configuration of the app.
 */
[Bindable]
public class ConfigurationModel {
    private static const EJB:String = "ejb";
    private static const WEB:String = "web";


	public var curveForm:String = "curve";

    public var chartEJBColor:uint = 39168;
    public var chartWEBColor:uint = 255;
    public var chartJNDIColor:uint = 10027008;
    public var dataAre:String = "Duration of invocations";
    public var auditSamples:int = 20;
    public var chartFilter:String = "duration";
    public var filterEJB:String = "durationejb";
    public var filterWEB:String = "durationweb";
    public var unit:String = "time (ms)";
	// Default is line series
    public var curve:Boolean = true;
    public var interpolate:Boolean = true;
    public var intervals:Array = [
        {
            label:"20 req.",
            data:20
        },
        {
            label:"40 req.",
            data:40
        },
        {
            label:"60 req.",
            data:60
        },
        {
            label:"80 req.",
            data:80
        },
        {
            label:"100 req.",
            data:100
        }
    ] ;
    public var filters:Array = [
        {
            label:"Request duration",
            data:"requestDuration",
            unit:"time (ms)"
        },
        {
            label:"Free memory before request",
            data:"freeMemoryBefore",
            unit:"size (bytes)"
        },
        {
            label:"Free memory after request",
            data:"freeMemoryAfter",
            unit:"size (bytes)"
        },
        {
            label:"GC sweep/mark time",
            data:"sweepMarkTime",
            unit:"time (ms)"
        },
        {
            label:"GC scavenge time",
            data:"scavengeTime",
            unit:"time (ms)"
        },
        {
            label:"Parameters Size",
            data:"paramSize" ,
            unit:"size (bytes)"
        }
    ] ;
    public var shape:Array = [
        {
            label:"Curve shape",
            data:true
        },
	    {
            label:"Column shape",
            data:false
	    }
	] ;

	public var curveForms:Array = [
		{
			label:"Curve",
			data:"curve"
		},
		{
			label:"Segment",
			data:"segment"
		},
	{
		label:"Step",
		data:"step"
	},
		{
		label:"Reverse Step",
		data:"reverseStep"
	},
	{
		label:"Vertical",
		data:"vertical"
	},
	{
		label:"Horizontal",
		data:"horizontal"
	}
	] ;


    public var tops:Array = [
        {
            label:"5 resources",
            data:5
        },
        {
            label:"10 resources",
            data:10
        },
        {
            label:"15 resources",
            data:15
        },
        {
            label:"20 resources",
            data:20
        }
    ] ;
    public function ConfigurationModel() { }
}
}