/**
 * JOnAS: Java(TM) Open Application Server
 * Copyright (C) 2010 Bull S.A.S.
 * Contact: jonas-team@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id:$
 * --------------------------------------------------------------------------
 */
package org.ow2.jonas.admin.auditconsole.view {
	import com.adobe.cairngorm.control.CairngormEventDispatcher;

	import flash.events.*;
	import flash.utils.Timer;

	import mx.collections.ArrayCollection;
	import mx.containers.Canvas;
	import mx.controls.Alert;
	import mx.controls.CheckBox;

	import org.ow2.jonas.admin.auditconsole.event.AuditConsoleEvent;
	import org.ow2.jonas.admin.auditconsole.model.AuditConsoleModelLocator;
	import org.ow2.jonas.admin.auditconsole.vo.GenericAuditReportVO;

public class MainViewClass extends Canvas {
    public function MainViewClass() {
    }

	/**
	 * Model used for this view.
	 */
	[Bindable]
	public var model : AuditConsoleModelLocator = AuditConsoleModelLocator.getInstance();

	[Bindable]
	public var selectedItem:Object;


	[Bindable]
	public var auditreport:GenericAuditReportVO;

	private var result:ArrayCollection = new ArrayCollection();

	[Bindable]
	public var appTimer : Timer = new Timer(1000);


	[Bindable]
	public var toggleTimerCheckBox : CheckBox = null;


	private var treeTarget:String = "";



	protected function init():void {
		// Not yet enabled
		model.listening = false;
		model.canObject = this;
		appTimer.addEventListener(TimerEvent.TIMER, updateTimer);
		var event:AuditConsoleEvent = new AuditConsoleEvent(AuditConsoleEvent.GET_REPORTS_OBJECTS);
		CairngormEventDispatcher.getInstance().dispatchEvent(event);
		startAudit();
	}

	protected function updateTimer(evt:TimerEvent):void {
		var event:AuditConsoleEvent = new AuditConsoleEvent(AuditConsoleEvent.GET_REPORTS_OBJECTS);
        var global:AuditConsoleEvent = new AuditConsoleEvent(AuditConsoleEvent.GET_GLOBAL_TOPS);
        var ejb:AuditConsoleEvent = new AuditConsoleEvent(AuditConsoleEvent.GET_EJB_TOPS);
        var web:AuditConsoleEvent = new AuditConsoleEvent(AuditConsoleEvent.GET_WEB_TOPS);
        var jndi:AuditConsoleEvent = new AuditConsoleEvent(AuditConsoleEvent.GET_JNDI_TOPS);
        var health:AuditConsoleEvent = new AuditConsoleEvent(AuditConsoleEvent.GET_SERVERHEALTH);

		CairngormEventDispatcher.getInstance().dispatchEvent(event);
        CairngormEventDispatcher.getInstance().dispatchEvent(global);
        CairngormEventDispatcher.getInstance().dispatchEvent(web);
        CairngormEventDispatcher.getInstance().dispatchEvent(jndi);
        CairngormEventDispatcher.getInstance().dispatchEvent(ejb);
        CairngormEventDispatcher.getInstance().dispatchEvent(health);

		if (appTimer.running) {
			toggleTimerCheckBox.selected = true;
		} else {
			toggleTimerCheckBox.selected = false;
		}
	}




	protected function audit():void {
		if (model.listening) {
			stopAudit();
		} else {
			startAudit();
		}
	}

	public function startAudit():void {
		var event:AuditConsoleEvent = new AuditConsoleEvent(AuditConsoleEvent.START_LISTENING);
		CairngormEventDispatcher.getInstance().dispatchEvent(event);
		model.listening = true;
		appTimer.start();
	}

	public function stopAudit():void {
		var event:AuditConsoleEvent = new AuditConsoleEvent(AuditConsoleEvent.STOP_LISTENING);
		CairngormEventDispatcher.getInstance().dispatchEvent(event);
		model.listening = false;
		appTimer.stop();
	}

	public function toggleTimer(event: Event):void {
		if (appTimer.running) {
			appTimer.stop();
		} else {
			appTimer.start();
		}
	}

}
}